﻿@using System.ComponentModel.DataAnnotations
@using System.Reflection
@using DayZLegacy.Pages
@using Shared

<div>
    <label>@Title</label>
    <div class="ml-5">
        @foreach (string name in Enum.GetNames(Value.GetType()))
        {
            <div class="d-flex justify-content-between align-content-center">
                <label class="container">@(Value.GetType()
                                             .GetMember(name)
                                             .FirstOrDefault()?
                                             .GetCustomAttribute<DisplayAttribute>()?
                                             .GetName() ?? name)
                    <input type="radio" 
                           value="@name" 
                           checked="@(Enum.GetName(Value.GetType(), Value) == name)"
                           @onchange="@HandleChangeAsync"/>
                    <span class="checkmark"></span>
                </label>
            </div>
        }
    </div>
</div>

@code {
    [Parameter]
    public string Title { get; set; } = "";
    
    [Parameter]
    public Enum Value { get; set; }
    
    [Parameter]
    public EventCallback<Enum> OnValueChanged { get; set; }

    protected override void OnInitialized()
    {
        if (!string.IsNullOrEmpty(Title)) return;
        var att = Value.GetType().GetCustomAttributes().FirstOrDefault(a => a is Display);
        Title = att is null ? Value.GetType().Name : (att as Display)?.Name;
    }

    private async Task HandleChangeAsync(ChangeEventArgs args)
    {
        if (args.Value is null)
        {
            return;
        }
        
        Value = (Enum)Enum.Parse(Value.GetType(), args.Value.ToString() ?? "");
        await OnValueChanged.InvokeAsync(Value);
    }
}